package com.galaxis.manatee.entity.chuanyun.data.object;

import com.dingtalk.api.response.OapiProcessinstanceGetResponse;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;

import javax.persistence.Entity;
import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * Created by IntelliJ IDEA.
 * User: xuj
 * Date: 2020/7/23
 * @author xuj
 */
@Slf4j
@EqualsAndHashCode(callSuper = true)
@Data
@Entity(name = "CHUANYUN_ASKFORLEAVE")
@JsonIgnoreProperties(ignoreUnknown = true)
public class ChuanyunAskForLeaveDo extends BasicDO {

    /**
     * 表名
     */
    public static final String SCHEMA_CODE ="c490c2213711480d8b2c3eee7099e39d";

    /**
     * 标题
     */
    @JsonProperty("title")
    private String title;

    /**
     * 抄送人
     */
    @JsonProperty("cs_userids")
    private String csUserids;

    /**
     * 操作
     */
    @JsonProperty("biz_action")
    private String bizAction;

    /**
     * 创建时间
     */
    @JsonProperty("create_time")
    private Date createTime;

    /**
     * 结束时间
     */
    @JsonProperty("finish_time")
    private Date finishTime;


    @JsonProperty("main_process_instance_id")
    private String mainProcessInstanceId;

    /**
     * 发起人
     */
    @JsonProperty("originator_userid")
    private String originatorUserid;

    /**
     * 发起部门
     */
    @JsonProperty("originator_dept_id")
    private String originatorDeptId;

    /**
     * 抄送人
     */
    @JsonProperty("cc_userids")
    private String ccUserId;

    /**
     * 审批结果: 同意 和 不同意
     */
    @JsonProperty("approvalResult")
    private String approvalResult;

    /**
     * 审批实例业务编号
     */
    @JsonProperty("business_id")
    private String businessId;

    /**
     * 发起部门
     */
    @JsonProperty("originator_dept_name")
    private String originatorDeptName;

    /**
     * 请假事由
     */
    @JsonProperty("leave_type")
    private String leaveType;

    /**
     * 劳动合同所属公司
     */
    @JsonProperty("contract_owner_ltd")
    private String contractOwnerLtd;

    @JsonProperty("result")
    private String result;

    /**
     * 根据ProcessInstanceTopVo获得chuanyunAskForLeaveDo
     * @param processInstanceTopVo   传输数据
     * @return  保存数据
     */
    public static ChuanyunAskForLeaveDo fromAskForLeaveDTO(OapiProcessinstanceGetResponse.ProcessInstanceTopVo processInstanceTopVo){
        ChuanyunAskForLeaveDo chuanyunAskForLeaveDo =new ChuanyunAskForLeaveDo();
        BeanUtils.copyProperties(processInstanceTopVo, chuanyunAskForLeaveDo);
        List<OapiProcessinstanceGetResponse.FormComponentValueVo> formComponentList = processInstanceTopVo.getFormComponentValues();
        if(formComponentList != null && formComponentList.size() > 0) {
            for (OapiProcessinstanceGetResponse.FormComponentValueVo formComponentValueVo : formComponentList) {
                if ("请假事由".equals(formComponentValueVo.getName())) {
                    chuanyunAskForLeaveDo.setLeaveType(formComponentValueVo.getValue());
                }
                if ("劳动合同所属公司".equals(formComponentValueVo.getName())) {
                    chuanyunAskForLeaveDo.setContractOwnerLtd(formComponentValueVo.getValue());
                }
            }
        }
        chuanyunAskForLeaveDo.setObjectId(UUID.randomUUID().toString());
        return chuanyunAskForLeaveDo;
    }

}
